﻿Option Strict On
Option Explicit On

Public Class frm03_Products

   'Basis-Code vom Assistenten (einzige Änderung = cmdSave-Bezug)
   Private Sub frmProducts_Load( _
            ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles MyBase.Load
      'TODO: This line of code loads data into the 'DsProducts.Products' table. 
      'You can move, or remove it, as needed.
      Me.ProductsTableAdapter.Fill(Me.DsProducts.Products)

      'Einzige Änderung hier: Save-Button deaktivieren
      cmdSave.Enabled = False
   End Sub

   'Speichern per Button - Basiscode vom Assistenten (für den per Wizard erzeugten Toolstrip)
   '+ manuelles Deaktivieren des Save-Buttons
   Private Sub cmdSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSave.Click
      Me.Validate()
      Me.ProductsBindingSource.EndEdit()
      Me.TableAdapterManager.UpdateAll(Me.DsProducts)

      'Einzige Änderung hier: Save-Button deaktivieren
      cmdSave.Enabled = False
   End Sub

   Private Sub ProductsDataGridView_CurrentCellDirtyStateChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ProductsDataGridView.CurrentCellDirtyStateChanged
      '"Dirty"-Event zu einer einzelnen Zelle - wird aufgerufen, 
      'sobald die erste Änderung in einer Zelle vorgenommen wurde
      cmdSave.Enabled = True
   End Sub

   'Automatisches Speichern beim Verlassen einer Zeile und an ihr vorgenommenen Änderungen
   Private Sub ProductsDataGridView_RowLeave(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles ProductsDataGridView.RowLeave
      'Typisches Beispiel für eines der Probleme bei der automatischen Datenbindung:
      'Wenn man nur eine Zeile ändert und in eine andere Zeile wechselt, hat der 
      'verwendete DataSet sinnigerweise noch nicht erkannt, dass Änderungen vorliegen,
      'das ist erst nach dem *zweiten* Zeilenwechsel der Fall.
      'Heißt im Klartext, um einen lokalen (sprich manuellen) DirtyState-Tracker kommt
      'man hier nicht umhin!
      If DsProducts.HasChanges Then
         'Für Experimentierwillige: hier mal einen Breakpoint setzen und anschließend
         '*eine* Zelle ändern:
         cmdSave_Click(sender, EventArgs.Empty)
      End If

      'Der Einfachheit halber wird hier nun einfach das obige Verhalten
      '"korrigiert", indem der Aktivierungsstatus des Save-Buttons geprüft wird.
      'Gleiches wäre analog natürlich noch in z.B. ProductsDataGridView.LostFocus oder 
      'Form.FormClosing zu implementieren.
      If cmdSave.Enabled Then
         cmdSave_Click(sender, EventArgs.Empty)
      End If
   End Sub

End Class